 <?php

require_once 'HTML/QuickForm2.php';

$form = new HTML_QuickForm2(
    'RegisterForm',
    'POST',
    [
        'action' => $_SERVER['PHP_SELF']
    ]
);

// Form field creation.

$fieldset = $form->addFieldset('Register form')
                 ->setLabel('Register');

$nickname = $fieldset->addText('nickname')
                     ->setLabel('Nickname: ');
$password = $fieldset->addPassword('password')
                     ->setLabel('Password: ');
$passwordRepeat = $fieldset->addPassword('password-repeat')
                     ->setLabel('Repeat password: ');

// Fields validation.

$nickname->addRule('required', 'Specify a nickname');
$nickname->addRule(
    'regex',
    'Nickname can only contain alphanumeric characters.',
    '/^[a-zA-Z0-9]+$/'
);
$password->addRule('required', 'Specify a password');
$password->addRule(
    'minlength',
    'Password has to be at least 8 characters long.',
    8
);
$passwordRepeat->addRule('required', 'Specify again the password');
$passwordRepeat->addRule(
    'callback',
    'The passwords do not match.',
    [
        'callback' => 
            function($arg1, $arg2) {
                return $arg1 === $arg2;
            },
        'arguments' => [
            $password->getValue(),
            $passwordRepeat->getValue()
        ]
    ]
);

$form->addSubmit('submit', ['value' => 'Register']);

if ($form->validate()) {
    echo 'Hello ' . $nickname->getValue() . ', you have been successfully registered.';
} else {
    echo $form;
}
