<?php

require_once('Validate.php');

/**
 * Checks if the given parameters are set. If one of the specified parameters
 * is not set, die() is called.
 *
 * @param $parameters The parameters to check.
 */
function checkGETParametersOrDie($parameters) {
    foreach ($parameters as $parameter) {
        isset($_GET[$parameter]) || die("Provide required '$parameter' parameter.");
    }
}

// Flow starts here.

checkGETParametersOrDie(['email', 'number', 'date']);

$validator = new Validate();

$email = $_GET['email'];
$number = $_GET['number'];
$date = $_GET['date'];

if ($validator->email($email)) {
    echo 'Valid email.<br>';
} else {
    echo 'Invalid email.<br>';
}

if ($validator->number($number, ['decimal' => ','])) {
    echo 'Valid number.<br>';
} else {
    echo 'Invalid number.<br>';
}

if ($validator->date($date, ['format' => '%d-%m-%Y'])) {
    echo 'Valid date.<br>';
} else {
    echo 'Invalid date.<br>';
}
