<?php

require_once('XML/Serializer.php');

$options = [
    'encoding'  => 'UTF-8',
    'indent'    => '    ',
];

$serializer = new XML_Serializer($options);

$data = [
    'XML_Serializer' => [
        'title'       => 'XML Serializer example',
        'description' => 'This is an example of XML serialization with XMl_Serializer PEAR package.',
        'link'        => 'http://pear.php.net/package/XML_Serializer',
        'attributes'  => [
            'nested element'  => 'This a nested element.',
            'another element' => 'More stuff.'
        ]
    ]
];

$serialized = $serializer->serialize($data);

if ($serialized) {
    echo 'Serialized data:<br>';
    echo '<pre>';
    echo htmlentities($serializer->getSerializedData());
    echo '</pre>';
} else {
    echo 'An error occurred serializing the data.';
}
